package org.ow2.choreos.chordevelopment.analysis.depanalyzer.entity;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class Choreography {

	private String ID;
	private String name;
	
	private Map<String, Participant> participants;
	private ChoreographySchema choreographySchema;
	
	public Choreography(String ID, String name){
		
		this.ID = ID;
		this.name = name;
		
		this.participants = new HashMap<String, Participant>();		
		this.choreographySchema = new ChoreographySchema();
	}
	
	public void addParticipant(Participant participant){
		this.participants.put(participant.getID(), participant);
	}
	
	public Participant getParticipant(String ID){
		return this.participants.get(ID);
	}
	
	public Participant getParticipantByName(String participantName){
		for(Participant participant : participants.values()){
			if(participantName.equals(participant.getName())){
				return participant;
			}
		}
		return null;
	}
	
	public void setParticipants(Collection<Participant> participants){
		for(Participant participant : participants){
			this.addParticipant(participant);
		}
	}
	
	public void addStep(Step step){
		this.choreographySchema.addStep(step);
	}
	
	public void addSteps(Collection<Step> steps){
		for(Step step : steps){
			this.addStep(step);
		}
	}
	
	public void setSteps(Collection<Step> steps){
		this.choreographySchema.setSteps(steps);
	}
	
	public Step getStep(String stepID){
		return this.choreographySchema.getStep(stepID);
	}
	
	public void addTransition(Transition transition){
		this.choreographySchema.addTransition(transition);
	}
	
	public void addTransitions(Collection<Transition> transitions){
		for(Transition transition : transitions){
			this.addTransition(transition);
		}
	}

	public void setTransitions(Collection<Transition> transitions) {
		this.choreographySchema.setTransitions(transitions);
	}

	public Set<TaskStep> getTaskSteps() {
		return this.choreographySchema.getTaskSteps();
	}

	public Set<SubchoreographyStep> getSubchoreographySteps() {
		return this.choreographySchema.getSubchoreographySteps();
	}
	
	public String toString(){
		return this.name;
	}
}