package org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.transitiveclosure;

import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.SimpleEdge;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.traversal.NonRecursiveDFS;

import edu.uci.ics.jung.graph.DirectedGraph;
import edu.uci.ics.jung.graph.DirectedSparseGraph;

/**
 * 
 * @author gustavo.ansaldi.oliva@hp.com
 *
 * @param <V> Vertex type
 * @param <E> Edge type
 */
public class TransitiveClosureDFS<V,E> extends NonRecursiveDFS<V,E>{

	private DirectedSparseGraph<V, SimpleEdge> transitiveClosure;
	
	public TransitiveClosureDFS(){
		
	}
	
	public DirectedGraph<V, SimpleEdge> getTransitiveClosureFrom(
			DirectedGraph<V, E> graph) {
		
		transitiveClosure = new DirectedSparseGraph<V, SimpleEdge>();
		
		for(V root: graph.getVertices()){
			super.traverse(graph, root);
		}
		
		return transitiveClosure;
	}

	@Override
	public void visit(V root, V v) {
		 transitiveClosure.addEdge(new SimpleEdge(root + "," + v), root, v);
	}

}