package org.ow2.choreos.chordevelopment.analysis.depanalyzer.sia.graph.algorithms;

import java.util.HashMap;
import java.util.Map;

import org.junit.Before;
import org.junit.Test;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.GraphAnalyzer;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.algorithms.centrality.CentralityAnalysis;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Edge;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.graph.entity.Vertex;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.tests.sia.util.GraphFactory;
import org.ow2.choreos.chordevelopment.analysis.depanalyzer.tests.sia.util.GraphFactory.TestGraph;

import edu.uci.ics.jung.graph.DirectedGraph;

public class GraphDegreeCentralityTest {

	private Map<TestGraph, DirectedGraph<Vertex,Edge>> graphs;
	private Map<TestGraph, CentralityAnalysis> expectedCentralities;
	private Map<TestGraph, CentralityAnalysis> actualCentralities;
	
	//@Before
	public void setUp() throws Exception {
		
		GraphFactory factory = new GraphFactory();
		graphs = factory.getAllGraphs();
		
		expectedCentralities = factory.getAllCentralities();
		actualCentralities = new HashMap<TestGraph, CentralityAnalysis>();
		
		GraphAnalyzer analyzer = new GraphAnalyzer(graphs.get(TestGraph.SIMPLE));
		actualCentralities.put(TestGraph.SIMPLE, analyzer.calculateCentralityAnalysis());
		
		analyzer = new GraphAnalyzer(graphs.get(TestGraph.COMPLEX));
		actualCentralities.put(TestGraph.COMPLEX, analyzer.calculateCentralityAnalysis());
		
		analyzer = new GraphAnalyzer(graphs.get(TestGraph.LOOP));
		actualCentralities.put(TestGraph.LOOP, analyzer.calculateCentralityAnalysis());
	}

	//@Test
	public void shouldCalculateSimpleGraphDegreeCentrality() {

		CentralityBaseTests.shouldCalculateGraphDegreeCentrality(
				expectedCentralities.get(TestGraph.SIMPLE), actualCentralities.get(TestGraph.SIMPLE));
	}
	
	//@Test
	public void shouldCalculateComplexGraphDegreeCentrality() {

		CentralityBaseTests.shouldCalculateGraphDegreeCentrality(
				expectedCentralities.get(TestGraph.COMPLEX), actualCentralities.get(TestGraph.COMPLEX));
	}

	//@Test
	public void shouldCalculateLoopGraphDegreeCentrality() {

		CentralityBaseTests.shouldCalculateGraphDegreeCentrality(
				expectedCentralities.get(TestGraph.LOOP), actualCentralities.get(TestGraph.LOOP));
	}

}
