#include "BPMNUnitTask.h"


BPMNUnitTask :: BPMNUnitTask(){
	init();
	succs = NULL;

	preds = new BPMNUnitTask*[MAX_SUCC];
	prbSucc = new float[MAX_SUCC];

	
}


void BPMNUnitTask :: init(){
	type = OPERATION;
	id = -1;	
	srt = 0;
	ec = 0;
	nloop = 0;
	
	predLoop = NULL;
	loop_starter = FALSE;
	
	predNumber = 0;
	succNumber = 0;
	marker = FALSE;
	marker2 = FALSE;
}

BPMNUnitTask :: BPMNUnitTask(int typevalue, int idval, float srtvalue, float ecvalue){
	type = typevalue;	
	id = idval;	
	srt = srtvalue;
	ec = ecvalue;
	nloop = 0;

	succs = NULL;
	predLoop = NULL;
	loop_starter = FALSE;


	predNumber = 0;
	succNumber = 0;
	prbSucc = new float[MAX_SUCC];
	marker = FALSE;
	marker2 = FALSE;

}


BPMNUnitTask :: ~BPMNUnitTask(){

	delete[] prbSucc;
}


void BPMNUnitTask :: setType(int typevalue){
	type = typevalue;
}

void BPMNUnitTask :: setSrt(float srtvalue){
	srt = srtvalue;
}

void BPMNUnitTask :: setEc(float ecvalue){
	ec = ecvalue;
}


void BPMNUnitTask :: setAva(float avavalue){
	ava = avavalue;
}


void BPMNUnitTask :: setRel(float relvalue){
	rel = relvalue;
}



int BPMNUnitTask :: getType(){
	return type;
}

int BPMNUnitTask :: getId(){
	return id;
}


void BPMNUnitTask :: setId(int v){
	id = v;
}

float BPMNUnitTask :: getSrt(){
	return srt;
}


float BPMNUnitTask :: getEc(){
	return ec;
}


float BPMNUnitTask :: getRel(){
	return rel;
}


float BPMNUnitTask :: getAva(){
	return ava;
}




void BPMNUnitTask :: increasePredNumber(){
	predNumber++;
}


void BPMNUnitTask :: setPred(BPMNUnitTask *t){

	preds[predNumber] = t;
	predNumber = predNumber + 1;
	
}

void BPMNUnitTask :: setleaf(BPMNUnitTask *l){
	leaf = l;
}



void BPMNUnitTask :: removeSuccessor(BPMNUnitTask *t){

	int i, j;

	if(succNumber == 0)
		return;
	i = 0;
	while((i < succNumber) && (succs[i] != t))
		i++;
	if(i == succNumber-1){
		if(succs[i] == t){
			succs[i] = NULL;
			succNumber--;
		}
	}else{
		for(j = i; j < succNumber-1; j++)
			succs[j] = succs[j+1];
		succs[succNumber-1] = NULL;
		succNumber --;
	}
}


void BPMNUnitTask :: removePredecessor(BPMNUnitTask *t){

	int i, j;

	if(predNumber == 0)
		return;
	i = 0;
	while((i < predNumber) && (preds[i] != t))
		i++;
	if(i == predNumber-1){
		if(preds[i] == t){
			preds[i] = NULL;
			predNumber--;
		}
	}else{
		for(j = i; j < predNumber-1; j++)
			preds[j] = preds[j+1];
		preds[predNumber-1] = NULL;
		predNumber --;
	}
}


void BPMNUnitTask :: removeallSuccessors(){
	int i;

	if(succNumber == 0)
		return;
	for(i = 0; i < succNumber; i++)
		succs[i] = NULL;
	succNumber = 0;
}


void BPMNUnitTask :: removeallPredecessors(){
	int i;
	for(i = 0; i < predNumber; i++)
		preds[i] = NULL;
	predNumber = 0;	
}


void BPMNUnitTask ::increaseSuccNumber(){
	succNumber++;
}

void BPMNUnitTask ::setProbability(int succi, float pi){
	prbSucc[succi] = pi;
}

void BPMNUnitTask :: setnloop(int n){
	nloop = n;
}


void BPMNUnitTask :: mark(){
	marker = TRUE;
}

void BPMNUnitTask :: mark2(){
	marker2 = TRUE;
}

int BPMNUnitTask :: isMarked(){
	return 	marker;
}

void BPMNUnitTask :: unmark(){
	marker = FALSE;
	marker2 = FALSE;
}

int BPMNUnitTask :: isMarked2(){
	return 	marker2;
}



