#include <cstdlib>
#include<iostream>
#include<time.h>
#include "OperationGraph.h"
using namespace std;




int main(int argc, char* argv[]){
/*
 * argv[1] is the model file. It describes the operations graph
 * argv[2] is the qos file. It comprises local QoS on operations
 * argv[3] is the probabilities file. It states the probabilities required on OR_SPLIT, XOR_SPLIT etc.
 
 For testing, try for instance:
 
 ./computeQoS_example Examples/ligo100Model.txt Examples/ligo100QoS.txt Examples/ligo100Prob.txt
 
*/
	
	srand(time(NULL));
	time_t start,end, start2, end2;
	
	OperationGraph *Go;
	if(argc < 3){
		cout<< "Not enough arguments \n";
		return -1;
	}	
	
	string model(argv[1]);
	string qos(argv[2]);
	string prob(argv[3]);
		
	Go = new OperationGraph;
	
	
	int nexp, i, j;
	int *Nexp;
	Nexp = new int[10];
	Nexp[0] = 10000;
	Nexp[1] = 20000;
	Nexp[2] = 30000;
	Nexp[3] = 40000;
	Nexp[4] = 50000;
	Nexp[5] = 60000;
	Nexp[6] = 70000;
	Nexp[7] = 80000;
	Nexp[8] = 90000;
	Nexp[9] = 100000;

	float powerMin, powerMax;

/* we assume that the power consumption on machines vary between 100 and 150 watts*/	
	powerMin = 100;
	powerMax = 150;

	Go->loadGraphSrt((char*)model.c_str(), (char*)qos.c_str(), (char*)prob.c_str(), powerMin, powerMax);
	// This will compute the EC as a function of the SRT. Use the more general loadGraph function alternatively. 
	for(nexp = 0; nexp < 10; nexp++){
		time(&start);
		for (j 
			 = 0; j < Nexp[nexp]; j++) {
			Go->reduce_with_order();
/* You can also try			
			Go->reduce_lex_order(); Reduce with the lexicographic ordering 
			Go->reduce_lex_order(); Reduce with a random ordering
 */
			Go->reloadGraphSrt((char*)model.c_str(), (char*)qos.c_str(), (char*)prob.c_str(), powerMin, powerMax);

		}
		time(&end);
		cout << "Exp No: " << nexp << " Reduction time = " << difftime(end, start) << endl;
		cout<<"srt = "<< Go->getSrt() << endl;
		cout<<"ec = "<< Go->getEc() << endl;

	}
	

	return 0;
}
