package it.univaq.di.choreos.coordinationprotocol.algorithm.impl;

import it.univaq.di.choreos.coordinationprotocol.algorithm.CoordinationChannelManager;
import it.univaq.di.choreos.coordinationprotocol.channel.client.AdditionalMessage;
import it.univaq.di.choreos.coordinationprotocol.channel.client.WSCoordinationChannel;
import it.univaq.di.choreos.coordinationprotocol.channel.client.WSCoordinationChannel_Service;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import javax.xml.namespace.QName;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CoordinationChannelManagerImpl implements CoordinationChannelManager {
	
	final Logger logger = LoggerFactory.getLogger(CoordinationChannelManagerImpl.class);
	
	private Map<String, String> coordinationDelegatesUrl = new HashMap<String, String>();
	
	public CoordinationChannelManagerImpl(Map<String, String> coordinationDelegatesUrl) {
		this.coordinationDelegatesUrl = coordinationDelegatesUrl;
	}

	@Override
	public void sendUpdateCurrentState(it.univaq.di.choreos.coordinationprotocol.algorithm.model.AdditionalMessage additionalMessage) {
		
		WSCoordinationChannel_Service coordinationChannelService = new WSCoordinationChannel_Service(createUrl(additionalMessage.getCoordinationDelegateTo()), new QName("http://choreos.di.univaq.it", "WSCoordinationChannel"));
		WSCoordinationChannel coordinationChannelPort = coordinationChannelService.getWSCoordinationChannelPort();
		AdditionalMessage newAdditionalMessage = new AdditionalMessage(); 
		newAdditionalMessage.setCoordinatedServiceEndpointName(additionalMessage.getCoordinatedServiceEndpointName());
		newAdditionalMessage.setChoreographyID(additionalMessage.getChoreographyID());
		newAdditionalMessage.setCoordinationDelegateFrom(additionalMessage.getCoordinationDelegateFrom());
		newAdditionalMessage.setCoordinationDelegateTo(additionalMessage.getCoordinationDelegateTo());
		newAdditionalMessage.setRequest(additionalMessage.getRequest());

		//coordinationChannelPort.sendUpdateCurrentState(newAdditionalMessage);
		
	}
	
	private URL createUrl(String coordinationDelegateTo) {
		
		String urlName = getParticipantUrl(coordinationDelegateTo);
		URL url = null;
        try {
            URL baseUrl;
            baseUrl = it.univaq.di.choreos.coordinationprotocol.channel.client.WSCoordinationChannel_Service.class.getResource(".");
            url = new URL(baseUrl, urlName);
        } catch (MalformedURLException e) {
        	logger.error("createUrl", e);
        }
        return url;
	}

	private String getParticipantUrl(String coordinationDelegateTo) {
		return coordinationDelegatesUrl.get(coordinationDelegateTo);
	}

}
