package it.univaq.di.choreos.coordinationprotocol.algorithm.model.queue;

import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CDQueueAck {

	final Logger logger = LoggerFactory.getLogger(CDQueueAck.class);

	private List<CDQueueElement> blockElements = new ArrayList<CDQueueElement>();
	

	public synchronized void addBlock(CDQueueElement element) {
		blockElements.add(element);
	}

	public synchronized void waitAllAcks() {
		if (!blockElements.isEmpty()) {
			try {
				wait();
			} catch (InterruptedException e) {
				logger.error("waitAllAcks", e);
			}
		}
	}

	public synchronized void removeAndNotify(CDQueueElement element) {
		blockElements.remove(element);
		if (blockElements.isEmpty()) {
			notifyAll();
		}
	}
}
