package it.univaq.di.choreos.coordinationprotocol.algorithm.model.queue;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.Participant;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.State;

public class CDQueueElement {
	
	private Participant coordinationDelegateFrom;
	private Participant coordinationDelegateTo;
	private State state;

	public CDQueueElement() {
		super();
	}
	
	public CDQueueElement(Participant coordinationDelegateFrom, Participant coordinationDelegateTo, State state) {
		this.coordinationDelegateFrom = coordinationDelegateFrom;
		this.coordinationDelegateTo = coordinationDelegateTo;
		this.state = state;
	}

	public Participant getCoordinationDelegateFrom() {
		return coordinationDelegateFrom;
	}

	public void setCoordinationDelegateFrom(Participant coordinationDelegateFrom) {
		this.coordinationDelegateFrom = coordinationDelegateFrom;
	}

	public Participant getCoordinationDelegateTo() {
		return coordinationDelegateTo;
	}

	public void setCoordinationDelegateTo(Participant coordinationDelegateTo) {
		this.coordinationDelegateTo = coordinationDelegateTo;
	}

	public State getState() {
		return state;
	}

	public void setState(State state) {
		this.state = state;
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((coordinationDelegateTo == null) ? 0 : coordinationDelegateTo.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CDQueueElement other = (CDQueueElement) obj;
		if (coordinationDelegateTo == null) {
			if (other.coordinationDelegateTo != null)
				return false;
		} else if (!coordinationDelegateTo.getName().equals(other.coordinationDelegateTo.getName()))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "CDQueueElement [coordinationDelegateFrom=" + coordinationDelegateFrom.getName() + ", coordinationDelegateTo=" + coordinationDelegateTo.getName()
				+ ", state=" + state.getName() + "]";
	}
	
	

}
