package it.univaq.di.choreos.coordinationprotocol.channel;

import it.univaq.di.choreos.coordinationprotocol.algorithm.CoordinationDelegateFactory;
import it.univaq.di.choreos.coordinationprotocol.algorithm.CoordinationDelegateAlgorithm;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.AdditionalMessage;
import it.univaq.di.choreos.coordinationprotocol.algorithm.model.CoordinationDelegateID;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@WebService(serviceName = "WSCoordinationChannel", targetNamespace = "http://choreos.di.univaq.it", portName = "WSCoordinationChannelPort")
public class WSCoordinationChannel {

	final Logger logger = LoggerFactory.getLogger(WSCoordinationChannel.class);

	@WebMethod(operationName = "updatecurrentstate")
	@Oneway
	public void updatecurrentstate(@WebParam(name = "additionalMessage") AdditionalMessage additionalMessage) {
		logger.info("received UpdateCurrentState message from " + additionalMessage);
		CoordinationDelegateID coordinationDelegateID = new CoordinationDelegateID();
		coordinationDelegateID.setCoordinatedServiceEndpointName(additionalMessage.getCoordinatedServiceEndpointName());
		coordinationDelegateID.setChoreographyID(additionalMessage.getChoreographyID());

		CoordinationDelegateAlgorithm algorithm = CoordinationDelegateFactory.getCoordinationDelegateAlgorithm(coordinationDelegateID);
		algorithm.receiveUpdateCurrentState(additionalMessage);

		logger.info("end block message from " + additionalMessage);
	}
}
