package it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel;

import it.univaq.di.choreos.coordinationprotocol.algorithm.model.coordmetamodel.impl.CoordmetamodelPackageImpl;

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.Date;

import org.apache.commons.io.FileUtils;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

public class CoordmetamodelParser {
	static {
		CoordmetamodelPackageImpl.init();
	}

	public static Coord parse(String modelFileName) {
		URI fileURI = URI.createFileURI(modelFileName);
		Resource resource = new XMIResourceFactoryImpl().createResource(fileURI);
		try {
			resource.load(null);
			Coord coord = (Coord) resource.getContents().get(0);
			return coord;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getCoordContent (Coord coord) {
		String result = "";
		String tempFolder = getTempFolder();
		File tempFolderDir = new File(tempFolder);
		try {
			FileUtils.forceMkdir(tempFolderDir);
			File coordFile = new File(tempFolder + File.separator + "coordtemp.xmi");
			saveModel (coordFile.getAbsolutePath() , coord);
			result = FileUtils.readFileToString(coordFile);
			FileUtils.deleteDirectory(tempFolderDir);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			try {
				FileUtils.deleteDirectory(tempFolderDir);
			} catch (IOException e) {}
		}
		return result;
	}
	
	
	
	
	private static boolean saveModel(String fullPathDestinationModel, Coord coord) {
		if (coord == null) {
			return false;
		}
			
		// create resource from the Model
		URI fileUriTempModelNormalized = URI.createFileURI(fullPathDestinationModel);
		Resource resourceCoord = new XMIResourceFactoryImpl().createResource(fileUriTempModelNormalized);
		// add model in model resourceModel
		resourceCoord.getContents().add(coord);
		try {
			// save new CLTS model
			resourceCoord.save(Collections.EMPTY_MAP);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}

		return true;

	}
	
	private static String getTempFolder() {
		return FileUtils.getTempDirectoryPath() + File.separator + getRandomDir() + File.separator;
	}

	private static String getRandomDir() {
		return new Date().getTime() + "";
	}
}
