package it.univaq.di.choreos.elts.strongsimulation;

import it.univaq.di.choreos.ELTS.Model;
/**
 * 
 * @author Alexander Perucci
 *
 */
public class NormalizeModel {

	private ELTSModel modelManager;
	
	/**
	 * 
	 * @param ELTSModel modelManager
	 */ 
	public NormalizeModel(ELTSModel modelManager) {
		this.modelManager = modelManager;
		normalizeModel();
	}
	
	/**
	 * 
	 * @return the model normalized
	 */
	public Model getModelNormalized (){
		return modelManager.getModel();
	}
	
	/**
	 * normalize Model
	 */
	private void normalizeModel(){
		
		// remove activity loop objects in model
		if (modelManager.getActivityLoops().size()>0){
			RemoveActivityLoopObjects removeActivityLoopObjects =new RemoveActivityLoopObjects(modelManager);
			executeRemoveEpsilonState2State();
		}
		
		// remove alternative objects in model
		if(modelManager.getAlternatives().size()>0){
			RemoveAlternativeObjects removeAlternativeObjects = new RemoveAlternativeObjects(modelManager);
			executeRemoveEpsilonState2State();
		}

		//remove fork objects in model
		if (modelManager.getForks().size()>0){
			RemoveForkObjects removeForkObjects =new RemoveForkObjects(modelManager);
			executeRemoveEpsilonState2State();
		}

	}
	/**
	 * remove epsilon state to state transitions
	 */
	private void executeRemoveEpsilonState2State(){
		//remove Epsilon State2State objects in Model
		if ((modelManager.getAllEpsilonState2StateTransitions()).size()>0){
			RemoveEpsilonState2StateObjects removeEpsilonState2StateObjects = new RemoveEpsilonState2StateObjects(modelManager);
		}
	}
}
