package it.univaq.di.choreos.elts.strongsimulation;

import it.univaq.di.choreos.ELTS.State;
import it.univaq.di.choreos.ELTS.Transition;

import java.util.ArrayList;
import java.util.List;

/**
 * 
 * @author Alexander Perucci
 *
 */
public class RepresentationTrackFork {
	
	private State startState;
	private State endState;
	private List<State> states;
	private List<Transition> state2StateTransitions;
	
	
	
	public RepresentationTrackFork(){
		startState = null;
		endState = null;
		states = new ArrayList<State>();
		state2StateTransitions = new ArrayList<Transition>();
	
		
	}
	
	//Start State
	public State getStartState() {
		return startState;
	}

	public void setStartState(State startState) {
		this.startState = startState;
	}

	//End State
	public State getEndState() {
		return endState;
	}
	public void setEndState(State endState) {
		this.endState=endState;
	}

	
	
	// State
	public List<State> getStates() {
		return states;
	}
	
	public void setStates(List<State> states) {
		this.states=states;
	}
	
	public State getState(String nameState){
		for (State state : states) {
			if (state.getName().compareTo(nameState)==0)
				return state;
			
		}
		return null;
	}
	
	//State2State Transition
	public List<Transition> getState2StateTransitions() {
		return state2StateTransitions;
	}
	public void setState2StateTransitions(List<Transition> state2StateTransitions) {
		this.state2StateTransitions =state2StateTransitions;
	}
	
	

	
	
	
	
	public List<State> getStatesWithSecondStateHold (State state, State stateHold ){
		List<State> ls =new ArrayList<State>();
		for (State stateSelected : states) {
			if (stateSelected.getName().split("/,/")[0].compareTo(state.getName())==0 && stateSelected.getName().split("/,/")[1].compareTo(stateHold.getName())==0)
				ls.add(stateSelected);
		}
		return ls;
	}
	
	
	public List<State> getStatesWithFirstStateHold (State state, State stateHold ){
		List<State> ls =new ArrayList<State>();
		for (State stateSelected : states) {
			if (stateSelected.getName().split("/,/")[1].compareTo(state.getName())==0 && stateSelected.getName().split("/,/")[0].compareTo(stateHold.getName())==0)
				ls.add(stateSelected);
		}
		return ls;
	}
	
	public void adjustsNameState (){
		for (State stateSelected : states) {
			stateSelected.setName(stateSelected.getName().replace("/,/", ""));
		}
	}
	



}
