package it.univaq.di.choreos.elts.strongsimulation.impl;

import it.univaq.di.choreos.ELTS.ActivityLoop;
import it.univaq.di.choreos.ELTS.ActivityLoop2State;
import it.univaq.di.choreos.ELTS.Alternative;
import it.univaq.di.choreos.ELTS.Alternative2State;
import it.univaq.di.choreos.ELTS.ELTSFactory;
import it.univaq.di.choreos.ELTS.FinalState;
import it.univaq.di.choreos.ELTS.Fork;
import it.univaq.di.choreos.ELTS.Fork2State;
import it.univaq.di.choreos.ELTS.InitialState;
import it.univaq.di.choreos.ELTS.InitialState2State;
import it.univaq.di.choreos.ELTS.Join;
import it.univaq.di.choreos.ELTS.Join2State;
import it.univaq.di.choreos.ELTS.LabeledState2State;
import it.univaq.di.choreos.ELTS.Operation;
import it.univaq.di.choreos.ELTS.OperationType;
import it.univaq.di.choreos.ELTS.State;
import it.univaq.di.choreos.ELTS.State2ActivityLoop;
import it.univaq.di.choreos.ELTS.State2Alternative;
import it.univaq.di.choreos.ELTS.State2FinalState;
import it.univaq.di.choreos.ELTS.State2Fork;
import it.univaq.di.choreos.ELTS.State2Join;
import it.univaq.di.choreos.ELTS.State2State;
import it.univaq.di.choreos.elts.strongsimulation.ELTSManager;

public class ELTSManagerImpl implements ELTSManager{

	/*
	 * create NamedElement
	 */
	
	@Override
	public State createState(String stateName) {
		State newState= ELTSFactory.eINSTANCE.createState();
		newState.setName(stateName);
		return newState;
	}

	@Override
	public Fork createFork(String forkName) {
		Fork newFork= ELTSFactory.eINSTANCE.createFork();
		newFork.setName(forkName);
		return newFork;
	}

	@Override
	public Join createJoin(String joinName) {
		Join newJoin= ELTSFactory.eINSTANCE.createJoin();
		newJoin.setName(joinName);
		return newJoin;
	}

	@Override
	public Alternative createAlternative(String alternativeName) {
		Alternative newAlternative= ELTSFactory.eINSTANCE.createAlternative();
		newAlternative.setName(alternativeName);
		return newAlternative;
	}

	@Override
	public ActivityLoop createActivityLoop(String activityLoopName) {
		ActivityLoop newActivityLoop= ELTSFactory.eINSTANCE.createActivityLoop();
		newActivityLoop.setName(activityLoopName);
		return newActivityLoop;
	}
	
	/*
	 * create Labeled Transition
	 */

	
	@Override
	public LabeledState2State createLabeledState2State(State source, State target,OperationType operationType, Operation operation) {
		LabeledState2State newLabeledState2State= ELTSFactory.eINSTANCE.createLabeledState2State();
		newLabeledState2State.setSource(source);
		newLabeledState2State.setTarget(target);
		newLabeledState2State.setLabel(operation);
		newLabeledState2State.setOperationType(operationType);
		return newLabeledState2State;
	}

	
	
	
	/*
	 * create Epsilon Transition
	 */
	
	@Override
	public Join2State createJoin2State(Join source, State target) {
		Join2State newJoin2State = ELTSFactory.eINSTANCE.createJoin2State();
		newJoin2State.setSource(source);
		newJoin2State.setTarget(target);
		return newJoin2State;
	}

	@Override
	public State2Fork createState2Fork(State source, Fork target) {
		State2Fork newState2Fork = ELTSFactory.eINSTANCE.createState2Fork();
		newState2Fork.setSource(source);
		newState2Fork.setTarget(target);
		return newState2Fork;
	}

	@Override
	public Fork2State createFork2State(Fork source, State target) {
		Fork2State newFork2State = ELTSFactory.eINSTANCE.createFork2State();
		newFork2State.setSource(source);
		newFork2State.setTarget(target);
		return newFork2State;
	}

	

	@Override
	public State2Join createState2Join(State source, Join target) {
		State2Join newState2Join = ELTSFactory.eINSTANCE.createState2Join();
		newState2Join.setSource(source);
		newState2Join.setTarget(target);
		return newState2Join;
	}

	

	@Override
	public InitialState2State createInitialState2State(InitialState source, State target) {
		InitialState2State newInitialState2State = ELTSFactory.eINSTANCE.createInitialState2State();
		newInitialState2State.setSource(source);
		newInitialState2State.setTarget(target);
		return newInitialState2State;
	}

	@Override
	public State2FinalState createState2FinalState(State source, FinalState target) {
		State2FinalState newState2FinalState = ELTSFactory.eINSTANCE.createState2FinalState();
		newState2FinalState.setSource(source);
		newState2FinalState.setTarget(target);
		return newState2FinalState;
	}

	@Override
	public State2Alternative createState2Alternative(State source, Alternative target) {
		State2Alternative newState2Alternative = ELTSFactory.eINSTANCE.createState2Alternative();
		newState2Alternative.setSource(source);
		newState2Alternative.setTarget(target);
		return newState2Alternative;
	}

	@Override
	public Alternative2State createAlternative2State(Alternative source, State target) {
		Alternative2State newAlternative2State = ELTSFactory.eINSTANCE.createAlternative2State();
		newAlternative2State.setSource(source);
		newAlternative2State.setTarget(target);
		return newAlternative2State;
	}

	@Override
	public State2ActivityLoop createState2ActivityLoop(State source, ActivityLoop target) {
		State2ActivityLoop newState2ActivityLoop = ELTSFactory.eINSTANCE.createState2ActivityLoop();
		newState2ActivityLoop.setSource(source);
		newState2ActivityLoop.setTarget(target);
		return newState2ActivityLoop;
	}

	@Override
	public ActivityLoop2State createActivityLoop2State(ActivityLoop source, State target) {
		ActivityLoop2State newActivityLoop2State = ELTSFactory.eINSTANCE.createActivityLoop2State();
		newActivityLoop2State.setSource(source);
		newActivityLoop2State.setTarget(target);
		return newActivityLoop2State;
	}

	

	@Override
	public State2State createState2State(State source, State target) {
		State2State newState2State = ELTSFactory.eINSTANCE.createState2State();
		newState2State.setSource(source);
		newState2State.setTarget(target);
		return newState2State;
	}


}
