package it.univaq.di.choreos.coordderivator;

import it.univaq.di.choreos.CLTS.NamedElement;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class NamedElementCoordMap {
	
	private Map<NamedElement, List<String>>  elements;
	
	public NamedElementCoordMap() {
		elements = new HashMap<NamedElement, List<String>>();
		
	}

	public void put(NamedElement key, String value) {
		List<String> current = elements.get(key);
		if (current == null) {
			current = new ArrayList<String>();
			elements.put(key, current);
		}
		current.add(value);
	}
	
	public void put(NamedElement key, List<String> values) {
		elements.put(key, values);
	}

	public String remove(NamedElement key) {
		List<String> current = elements.get(key);
		if (current.size() == 1) {
			return elements.remove(key).get(0);
		} else {
			return current.remove(0);
		}
	}

	public boolean containValue(NamedElement key, String value) {
		List<String> current = elements.get(key);
		if (current != null) {
			for (String string : current) {
				if (string.equals(value))
					return true;
			}
		}
		return false;
	}
	
	public List<String> get(NamedElement key) {
		return elements.get(key);
	}
	
	public boolean containsKey(NamedElement key) {
		return elements.containsKey(key);
	}
	
	public Set<NamedElement> keySet() {
		return elements.keySet();

	}

}
