package it.univaq.di.choreos.stockbuy;

import it.fineco.trading.client.Stocktrade2;
import it.fineco.trading.client.Stocktrade2_Service;
import it.iwbank.trading.client.Stocktrade3;
import it.iwbank.trading.client.Stocktrade3_Service;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.ubs.trading.client.Stocktrade1;
import com.ubs.trading.client.Stocktrade1_Service;

@WebService( serviceName="StockBuy", targetNamespace="http://choreos.di.univaq.it", portName="StockBuyPort" )
public class StockBuy {
	
	final Logger logger = LoggerFactory.getLogger(StockBuy.class);
	
	@WebMethod( operationName="buy" )
	@Oneway
	public void buy( @WebParam( name="stockSymbol" ) String stockSymbol, @WebParam( name="quantity" ) int quantity ) {
		logger.debug("begin buy");

		logger.debug("before ubs->Stocktrade->buy1");
		Stocktrade1_Service stockTradeService = new Stocktrade1_Service();
		Stocktrade1 stockTradePort = stockTradeService.getStocktrade1Port();
		stockTradePort.buy1("1", stockSymbol, quantity);
		logger.debug("end ubs->Stocktrade->buy1");

		logger.debug("before fineco->Stocktrade->buy2");
		Stocktrade2_Service titoliAzionariService = new Stocktrade2_Service();
		Stocktrade2 titoliAzionariPort = titoliAzionariService.getStocktrade2Port();
		titoliAzionariPort.buy2("1", stockSymbol, quantity);
		logger.debug("end fineco->Stocktrade->buy2");


		logger.debug("before iwbank->Stocktrade->buy3");
		Stocktrade3_Service acquistoAzioniService = new Stocktrade3_Service();
		Stocktrade3 acquistoAzioniPort = acquistoAzioniService.getStocktrade3Port();
		acquistoAzioniPort.buy3("1", stockSymbol, quantity);
		logger.debug("end iwbank->Stocktrade->buy3");
	}
}
