package it.univaq.di.choreos.synthesis.servicediscovery.rest;

import it.univaq.di.choreos.synthesis.datamodel.Service;
import it.univaq.di.choreos.synthesis.datamodel.ServiceDiscoveryInput;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscovery;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscoveryException;
import it.univaq.di.choreos.synthesis.servicediscovery.impl.ServiceDiscoveryImpl;

import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RestServiceDiscovery {
	private static Logger logger = LoggerFactory.getLogger(RestServiceDiscovery.class);
	private ServiceDiscovery serviceDiscovery = new ServiceDiscoveryImpl();

	@Path("/discoverServices")
	@POST
	@Consumes(MediaType.APPLICATION_XML)
	@Produces(MediaType.APPLICATION_XML)
	public Response discoverServices(ServiceDiscoveryInput serviceDiscoveryInput) {
		if (serviceDiscoveryInput == null) {
			return Response.status(Status.BAD_REQUEST).build();
		}

		try {
			List<Service> result = serviceDiscovery.discoverServices(serviceDiscoveryInput);
			ResponseDiscoverServices entity = new ResponseDiscoverServices(result);
			return Response.ok().entity(entity).build();
		} catch (ServiceDiscoveryException e) {
			logger.error("error", e);
			return Response.status(Status.INTERNAL_SERVER_ERROR).build();
		}

	}

}
