package it.univaq.di.choreos.synthesis.rest;

import org.apache.cxf.jaxrs.JAXRSServerFactoryBean;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RESTServer implements Runnable {

	private static Logger logger = LoggerFactory.getLogger(RESTServer.class);

	private String name;
	private String url;
	private Class<?>[] classes;
	private boolean running = false;

	public RESTServer(String name, String url, Class<?>[] classes) {

		this.name = name;
		this.url = url;
		this.classes = classes;
	}

	public void start() {

		new Thread(this).start();
		while (!running) {
			try {
				Thread.sleep(1);
			} catch (InterruptedException e) {
				logger.error("", e);
			}
		}

	}

	public void stop() {
		running = false;
	}

	public void run() {

		JAXRSServerFactoryBean sf = new JAXRSServerFactoryBean();
		for (Class<?> cls : this.classes) {
			sf.setResourceClasses(cls);
		}
		sf.setAddress(this.url);
		sf.create();
		logger.info(this.name + " has started [" + this.url + "]");
		running = true;

		while (running) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		logger.info(this.name + " has stopped");
	}

}