package it.univaq.di.choreos.synthesis.synthesisprocessor.impl;

import it.univaq.di.choreos.synthesis.datamodel.CoordModel;
import it.univaq.di.choreos.synthesis.datamodel.Participant;
import it.univaq.di.choreos.synthesis.datamodel.Service;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ParticipantWithDependencies {
	
	private String participantName;
	
	private Map<String, CDData> cdDependencies;
	private Service service;
	
	private void init(List<CoordModel> dependencies){
		cdDependencies = new HashMap<String, CDData>();
		for (CoordModel participantTarget : dependencies) {
			CDData cdData = new CDData(participantTarget.getCdName(), participantName, participantTarget.getParticipantTargetName(), participantTarget.getCoordModel());
			this.cdDependencies.put(participantTarget.getParticipantTargetName(), cdData);
		}
	}
	
	public ParticipantWithDependencies(Participant participant) {
		this.participantName = participant.getName();
		init(participant.getCoordModels());
		
	}
	public Collection<CDData> getDependencies() {
		return cdDependencies.values();
	}

	public Service getService() {
		return service;
	}
	public void setService(Service service) {
		this.service = service;
	}
	
	public String getName() {
		return participantName;
	}
	
}
