package it.univaq.di.choreos.synthesis.synthesisprocessor.rest.client;

import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.SynthesisResult;
import it.univaq.di.choreos.synthesis.synthesisprocessor.SynthesisProcessor;
import it.univaq.di.choreos.synthesis.synthesisprocessor.SynthesisProcessorException;

import javax.ws.rs.WebApplicationException;

import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.transport.http.HTTPConduit;
import org.apache.cxf.transports.http.configuration.HTTPClientPolicy;

public class SynthesisProcessorClient implements SynthesisProcessor {

	private String host;

	public SynthesisProcessorClient(String host) {
		this.host = host;
	}

	private WebClient setupClient() {

		WebClient client = WebClient.create(host);

		// remove time out
		// not proud of it!
		HTTPConduit http = (HTTPConduit) WebClient.getConfig(client).getConduit();
		HTTPClientPolicy httpClientPolicy = new HTTPClientPolicy();
		httpClientPolicy.setConnectionTimeout(0);// indefined
		httpClientPolicy.setReceiveTimeout(0);// indefined
		http.setClient(httpClientPolicy);

		return client;
	}

	public SynthesisResult startSynthesis(ChoreographyBPMNSpecification bpmnSpecification) throws SynthesisProcessorException {
		WebClient client = setupClient();
		client.path("synthesis");
		try {
			return client.post(bpmnSpecification, SynthesisResult.class);
		} catch (WebApplicationException e) {
			throw new SynthesisProcessorException();
		}
	}

}
