package it.univaq.di.choreos.synthesis.synthesisprocessor.client;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

import it.univaq.di.choreos.synthesis.synthesisprocessor.SynthesisProcessorException;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.SynthesisResult;
import it.univaq.di.choreos.synthesis.synthesisprocessor.rest.client.SynthesisProcessorClient;


public class SynthesisProcessorWP7ClientTest {

	private static final String HOST = "http://localhost:10000/synthesisprocessor";
	private static final String WP7_BPMN = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp7" + File.separator + "bpmn-input"+ File.separator + "wp7.bpmn2";

	
	
	public static void main(String[] args) {
		SynthesisProcessorClient client = new SynthesisProcessorClient(HOST);
		ChoreographyBPMNSpecification bpmnSpecification = new ChoreographyBPMNSpecification(); 
		bpmnSpecification.setChoreographyName("wp7");
		try {
			String bpmnContent = FileUtils.readFileToString(new File(WP7_BPMN));
			bpmnSpecification.setBpmnSpecification(bpmnContent);
			SynthesisResult result = client.startSynthesis(bpmnSpecification);
			if (result.isResult()) {
				System.out.println("chorspec=" + result.getChorSpec());
			}
		} catch (SynthesisProcessorException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}
}
