package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp6;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import it.univaq.di.choreos.synthesis.cdgenerator.CDGenerator;
import it.univaq.di.choreos.synthesis.cdgenerator.CDGeneratorException;
import it.univaq.di.choreos.synthesis.cdgenerator.impl.CDGeneratorImpl;
import it.univaq.di.choreos.synthesis.datamodel.CD;

public class WP6CDGenerator implements CDGenerator {
	
	private Map<String, String> cdDestination;
	private CDGenerator cdGenerator;
	private String cdHomeRepository = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp6" + File.separator + "cd-output"+ File.separator;

	public WP6CDGenerator() {
		cdGenerator = new CDGeneratorImpl(cdHomeRepository);
		cdDestination = new HashMap<String, String>();
		cdDestination.put("CD-AIR-ABC","airport");
		cdDestination.put("CD-AIR-ADAA","airport");
		cdDestination.put("CD-AIR-AISA","airport");
		cdDestination.put("CD-AIR-ANSA","airport");
		cdDestination.put("CD-AIR-AP","airport");
		cdDestination.put("CD-AIR-APSA","airport");
		cdDestination.put("CD-AIR-ASAA","airport");
		cdDestination.put("CD-AIR-ASIAA","airport");
		cdDestination.put("CD-AIR-LHC","airport");
		cdDestination.put("CD-AIR-MIDDAA","airport");
		cdDestination.put("CD-AIR-MIDLSA","airport");
		cdDestination.put("CD-AIR-MIDMSA","airport");
		cdDestination.put("CD-AIR-SC","airport");
		cdDestination.put("CD-AIR-SGM","airport");
		cdDestination.put("CD-ABC-AIR","airportbuscompany");
		cdDestination.put("CD-AISA-AIR","airportinfraredsensorsaggregator");
		cdDestination.put("CD-ATC-AIR","airtrafficcontrol");
		cdDestination.put("CD-LHC-AIR","luggagehandlingcompany");
		cdDestination.put("CD-SC-AIR","securitycompany");
		cdDestination.put("CD-SGM-AIR","standandgatemanagement");
	}

	public String generate(CD cd) throws CDGeneratorException {
		cd.setParentFolderName(cdDestination.get(cd.getCdName()));
		String result = cdGenerator.generate(cd);
		return "http://localhost" + result;
	}

	@Override
	public byte[] getCD(String choreographyName, String cdDir, String cdName) throws CDGeneratorException {
		return null;
	}

}
