package it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7;

import it.univaq.di.choreos.synthesis.cdgenerator.CDGenerator;
import it.univaq.di.choreos.synthesis.cdgenerator.CDGeneratorException;
import it.univaq.di.choreos.synthesis.cdgenerator.impl.CDGeneratorImpl;
import it.univaq.di.choreos.synthesis.datamodel.CD;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class WP7CDGenerator implements CDGenerator {
	
	private Map<String, String> cdDestination;
	private CDGenerator cdGenerator;
	private String cdHomeRepository = "." + File.separator + "src" + File.separator + "test" + File.separator + "resources" + File.separator + "wp7" + File.separator + "cd-output"+ File.separator;

	public WP7CDGenerator() {
		cdGenerator = new CDGeneratorImpl(cdHomeRepository);
		cdDestination = new HashMap<String, String>();
		cdDestination.put("CD-Client-SelfCheckOutMachine","Client");
		cdDestination.put("CD-Client-ShopEntrance","Client");
		cdDestination.put("CD-Client-SmartCart","Client");
		cdDestination.put("CD-MarketingApplication-BasicComunicationDevice","MarketingApplication");
		cdDestination.put("CD-MarketingApplication-InStoreTotem","MarketingApplication");
		cdDestination.put("CD-MarketingApplication-MarketingManager","MarketingApplication");
		cdDestination.put("CD-MarketingApplication-ShoppingAssistants","MarketingApplication");
		cdDestination.put("CD-MarketingManager-MarketingApplication","MarketingManager");
		cdDestination.put("CD-SelfCheckOutMachine-MarketingApplication","SelfCheckOutMachine");
		cdDestination.put("CD-SelfCheckOutMachine-SmartCart","SelfCheckOutMachine");
		cdDestination.put("CD-ShopEntrance-MarketingApplication","ShopEntrance");
		cdDestination.put("CD-SmartCart-SelfCheckOutMachine","SmartCart");
		
	}

	public String generate(CD cd) throws CDGeneratorException {
		cd.setParentFolderName(cdDestination.get(cd.getCdName()));
		String result = cdGenerator.generate(cd);
		return "http://localhost" + result;
	}

	@Override
	public byte[] getCD(String choreographyName, String cdDir, String cdName) throws CDGeneratorException {
		return null;
	}

}