package it.univaq.di.choreos.synthesis.synthesisprocessor.impl;

import it.univaq.di.choreos.synthesis.behavioursimulator.BehaviourSimulator;
import it.univaq.di.choreos.synthesis.cdgenerator.CDGenerator;
import it.univaq.di.choreos.synthesis.datamodel.ChoreographyBPMNSpecification;
import it.univaq.di.choreos.synthesis.datamodel.SynthesisResult;
import it.univaq.di.choreos.synthesis.m2mtransformator.M2MTransformator;
import it.univaq.di.choreos.synthesis.servicediscovery.ServiceDiscovery;
import it.univaq.di.choreos.synthesis.synthesisprocessor.SynthesisProcessor;
import it.univaq.di.choreos.synthesis.synthesisprocessor.SynthesisProcessorException;
import it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7.WP7M2MTransformator;
import it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7.WP7BehaviourSimulator;
import it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7.WP7CDGenerator;
import it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7.WP7ChoreographyDeployer;
import it.univaq.di.choreos.synthesis.synthesisprocessor.dummies.wp7.WP7ServiceDiscovery;

import java.io.IOException;

import javax.xml.bind.JAXBException;

import org.junit.Before;
import org.junit.Test;
import org.ow2.choreos.chors.ChoreographyNotFoundException;

public class SynthesisProcessorImplTestWP7 {
	private BehaviourSimulator behaviourSimulator;
	private CDGenerator cdGenerator;
	private M2MTransformator m2mTransformator;
	private ServiceDiscovery serviceDiscovery;
	private WP7ChoreographyDeployer choreographyDeployer;
	private SynthesisProcessor synthesisProcessor;

	
	@Before
	public void setUp() {
	}

	@Test
	public void test01() throws SynthesisProcessorException, ChoreographyNotFoundException, JAXBException, IOException {

		m2mTransformator = new WP7M2MTransformator();

		boolean simulationResult = true;
		behaviourSimulator = new WP7BehaviourSimulator(simulationResult);
		serviceDiscovery = new WP7ServiceDiscovery();
		cdGenerator = new WP7CDGenerator();
		choreographyDeployer = new WP7ChoreographyDeployer("1");

		synthesisProcessor = new SynthesisProcessorImpl(behaviourSimulator, cdGenerator, m2mTransformator, serviceDiscovery, choreographyDeployer);

		ChoreographyBPMNSpecification bpmnSpecification = new ChoreographyBPMNSpecification();
		SynthesisResult result = synthesisProcessor.startSynthesis(bpmnSpecification);

		org.junit.Assert.assertTrue(result.isResult());
		String choreographyDeployerString = result.getChorSpec();
		

		// String chorSpec = FileUtils.readFileToString(new File(resourcesTest +"ChorSpec.xml"));
		// System.out.println(choreographyDeployerString);
		// org.junit.Assert.assertEquals(chorSpec.trim().replaceAll("[\n\r]",""), choreographyDeployerString.trim().replaceAll("[\n\r]", ""));

	}
}
